// este programa ejemplifica una implementacin de un rbol binario de bsqueda
// esta implementacin es recursiva, es ms fcil de entender que la iterativa que estaba intentando hacer los ltimos minutos de la clase
#include <iostream>
using namespace std;

struct nodo {                       // cada nodo del rbol guarda un valor y dos apuntadores
   int valor;                       // uno al hijo izquierdo (opcional, puede ser nulo)
   nodo* izq = nullptr;             // y el otro al hijo derecho (opcional, puede ser nulo)
   nodo* der = nullptr;
};

struct arbol {
   nodo* raiz = nullptr;            // un rbol guarda un apuntador a su nodo raz (el rbol est vaco si el apuntador es nulo)
};

void inserta(nodo*& n, int v)       // tomamos el apuntador por referencia, si es modificado entonces el llamante podr ver el cambio
{
   if (n == nullptr) {              // nos piden insertar y llegamos a un apuntador nulo, entonces el nuevo nodo lo creamos ah
      n = new nodo{v};              // la sintaxis nodo{v} inicializa directamente los miembros del struct (cero o nulo para los miembros no mencionados)
   } else if (v < n->valor) {       // si n apunta a un nodo ya creado, entonces bajamos por el lado izquierdo si el valor que queremos insertar es menor al del nodo actual
      inserta(n->izq, v);
   } else {                         // si n apunta a un nodo ya creado, entonces bajamos por el lado derecho si el valor que queremos insertar no es menor al del nodo actual
      inserta(n->der, v);
   }
}

bool busca(const nodo* n, int v)    // tomamos el apuntador por valor, es barato de copiar y no necesitamos modificarlo
{
   if (n == nullptr) {              // nos piden buscar y llegamos a un apuntador nulo, entonces el valor no est
      return false;
   } else if (v == n->valor) {      // si n apunta a un nodo ya creado que tiene el valor buscado, devolvemos que ya lo encontramos
      return true;
   } else if (v < n->valor) {       // si n apunta a un nodo ya creado, entonces bajamos por el lado izquierdo si el valor que buscamos es menor al del nodo actual
      return busca(n->izq, v);
   }  else {                        // si n apunta a un nodo ya creado, entonces bajamos por el lado derecho si el valor que buscamos no es menor al del nodo actual
      return busca(n->der, v);
   }
}

void inserta(arbol& a, int v)       // cuando nos piden insertar un nuevo elemento a un rbol, delegamos a la funcin que toma un apuntador a nodo y mandamos la raz
{
   inserta(a.raiz, v);
}

bool busca(const arbol& a, int v)   // cuando nos piden buscar un valor en un rbol, delegamos a la funcin que toma un apuntador a nodo y mandamos la raz
{
   return busca(a.raiz, v);
}

int main( )
{
   arbol a;
   inserta(a, 5);
   inserta(a, 3);
   inserta(a, 7);
   inserta(a, 1);
   inserta(a, 8);
   inserta(a, 4);

   for (int i = 0; i <= 10; ++i) {
      cout << i << ": " << busca(a, i) << "\n";
   }
}
